// (C) Copyright 2014-2016, Jaime Ferreira, David Martins de Matos, Ricardo Ribeiro
// Spoken Language Systems Lab, INESC ID, IST/Universidade de Lisboa

// This file is part of XOKDE++.

// XOKDE++ is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your
// option) any later version.

// XOKDE++ is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA

#ifndef SRC_INCLUDE_SPLIT_CLASSIFIER_H_
#define SRC_INCLUDE_SPLIT_CLASSIFIER_H_

#include "classifier/classifier.h"
#include "dataset/split_dataset.h"

namespace xokdepp {

  template<typename label_type>
  class split_classifier: public classifier<label_type> {
  public:
    split_dataset<label_type> _dataset_to_evaluate;

  public:
    split_classifier(const split_dataset<label_type> &dataset_to_evaluate) :
        _dataset_to_evaluate(dataset_to_evaluate) {
    }

    size_t number_of_classes() {
      return _dataset_to_evaluate.number_of_classes();
    }

    size_t number_of_evaluated_samples() {
      return _dataset_to_evaluate.test_size();
    }

  };

}

#endif /* SRC_INCLUDE_SPLIT_CLASSIFIER_H_ */
